Index: faq.html.template
===================================================================
RCS file: /cvsroot/matplotlib/htdocs/faq.html.template,v
retrieving revision 1.60
diff -u -b -B -w -p -r1.60 faq.html.template
--- faq.html.template	29 Jul 2005 16:43:35 -0000	1.60
+++ faq.html.template	9 Dec 2005 03:06:53 -0000
@@ -671,9 +671,9 @@ of them. 
 
 <h4>Image generation</h4>
 
-For pure image generation (no GUI) you can choose from the Agg, Cairo, PS,
-SVG, Paint or GD backends.  At this point, I advise people to use the <a
-href=http://antigrain.com>agg</a> backend because:
+For pure image generation (no GUI) you can choose from the Agg, Cairo,
+PS, SVG, Paint, GD or EMF backends.  At this point, I advise people to
+use the <a href=http://antigrain.com>agg</a> backend because:
 
 <ul>
   <li>it's the fastest</li>
Index: backends.html.template
===================================================================
RCS file: /cvsroot/matplotlib/htdocs/backends.html.template,v
retrieving revision 1.30
diff -u -b -B -w -p -r1.30 backends.html.template
--- backends.html.template	29 Jul 2005 16:43:35 -0000	1.30
+++ backends.html.template	9 Dec 2005 03:06:54 -0000
@@ -38,6 +38,7 @@ command, the backend can be chosen from 
 > python subplot_demo.py -dSVG     # SVG backend
 > python subplot_demo.py -dGD      # GD backend
 > python subplot_demo.py -dPaint   # Paint backend
+> python subplot_demo.py -dEMF     # EMF backend
 </pre>
 
 
@@ -67,12 +68,13 @@ href=matplotlib.backends.backend_cairo.h
 href=matplotlib.backends.backend_gtk.html>GTK</a>, <a
 href=matplotlib.backends.backend_gtkagg.html>GTKAgg</a>, <a
 href=matplotlib.backends.backend_gtkcairo.html>GTKCairo</a>, <a
-href=matplotlib.backends.backend_ps.html>PS</a> <a
-href=matplotlib.backends.backend_tkagg.html>TkAgg</a> <a
-href=matplotlib.backends.backend_wx.html>WX</a> <a
-href=matplotlib.backends.backend_wxagg.html>WXAgg</a> <a
-href=matplotlib.backends.backend_paint.html>Paint</a> and <a
+href=matplotlib.backends.backend_ps.html>PS</a>, <a
+href=matplotlib.backends.backend_tkagg.html>TkAgg</a>, <a
+href=matplotlib.backends.backend_wx.html>WX</a>, <a
+href=matplotlib.backends.backend_wxagg.html>WXAgg</a>, <a
+href=matplotlib.backends.backend_paint.html>Paint</a>, <a
 href=matplotlib.backends.backend_gd.html>GD</a>, <a
+href=matplotlib.backends.backend_emf.html>EMF</a> and <a
 href=matplotlib.backends.backend_template.html>Template</a>.
 
 The default is GTKAgg.  Template is a do nothing backend that serves as a
@@ -105,6 +107,7 @@ this page below or by clicking
 <li><a href=backends.html#PS>PS</a></li>
 <li><a href=backends.html#Paint>Paint</a></li>
 <li><a href=backends.html#GD>GD</a></li>
+<li><a href=backends.html#EMF>EMF</a></li>
 </ul>
 
 
@@ -304,7 +307,7 @@ are instructions for building gdmodule.
   href=http://newcenturycomputers.net/projects/gdmodule.html>gdmodule-0.52</a>
   -- The python interface to the gd module.</li>
 
-
+  </ul>
 
 <h4><a name=GDWIN32>Quick install guide for GD output: Windows</a></h4>
 
@@ -347,6 +350,21 @@ libart is highly portable, and the paint
 work on win32 and linux.  The pypaint web site has a src distribution
 and a windows installer.<p>
 
+
+
+<a name=EMF><h3>EMF</h3></a>
+
+Rob McMullen has written an Enhanced Metafile (EMF) backend for
+matplotlib, which requires <a
+href="http://pyemf.sourceforge.net">pyemf</a> version 2.0.0b1 (or
+newer).  EMF is a vector graphics format supported by the
+cross-platform OpenOffice suite as well as most Windows office
+applications.  EMF images can also be embedded within Rich Text Format
+(.rtf) files to create a single document with multiple plots. <p>
+
+
+
+
 @footer@
 
 
Index: installing.html.template
===================================================================
RCS file: /cvsroot/matplotlib/htdocs/installing.html.template,v
retrieving revision 1.33
diff -u -b -B -w -p -r1.33 installing.html.template
--- installing.html.template	29 Jul 2005 16:43:35 -0000	1.33
+++ installing.html.template	9 Dec 2005 03:06:54 -0000
@@ -7,15 +7,16 @@ some of the optional GUI and image exten
 Matplotlib is known to work on linux, unix, win32 and OS X platforms.<p>
 
 There are two kinds of matplotlib backends: vector based and raster
-based.  The vector based backends, SVG and PS, produce ASCII text
-output files *.svg and *.ps.  The core raster based renderer is the <a
-href=http://antigrain.com>antigrain</a> (agg) backend.  This is a high
-quality 2D library that supports fast antialiasing, alpha blending and
-much more.  If you want to produce PNGs or GUI images that support all
-of matplotlib's features, you should compile matplotlib with agg
-support and use one of the GUI agg backends as described below:
-GTKAgg, WXAgg, TkAgg or FLTKAgg.  All of these features are included
-in the windows installer<p>
+based.  Two vector based backends, SVG and PS, produce ASCII text
+output files *.svg and *.ps; the other vector based backend, EMF,
+produces binary output files *.emf.  The core raster based renderer is
+the <a href=http://antigrain.com>antigrain</a> (agg) backend.  This is
+a high quality 2D library that supports fast antialiasing, alpha
+blending and much more.  If you want to produce PNGs or GUI images
+that support all of matplotlib's features, you should compile
+matplotlib with agg support and use one of the GUI agg backends as
+described below: GTKAgg, WXAgg, TkAgg or FLTKAgg.  All of these
+features are included in the windows installer<p>
 
 <h2><a name=compiling>Compiling</a></h2>
 
Index: hthelpers.py
===================================================================
RCS file: /cvsroot/matplotlib/htdocs/hthelpers.py,v
retrieving revision 1.13
diff -u -b -B -w -p -r1.13 hthelpers.py
--- hthelpers.py	15 Jun 2005 18:29:25 -0000	1.13
+++ hthelpers.py	9 Dec 2005 03:06:54 -0000
@@ -14,6 +14,7 @@ modules = (
     'matplotlib.backends.backend_paint',
     'matplotlib.backends.backend_ps',
     'matplotlib.backends.backend_svg',    
+    'matplotlib.backends.backend_emf',    
     'matplotlib.backends.backend_template',
     'matplotlib.backends.backend_tkagg',
     'matplotlib.backends.backend_qt',