Index: lib/matplotlib/legend.py
===================================================================
--- lib/matplotlib/legend.py	(revision 6220)
+++ lib/matplotlib/legend.py	(working copy)
@@ -36,6 +36,8 @@
 from text import Text
 from transforms import Affine2D, Bbox, BboxTransformTo
 
+from itertools import cycle, izip
+
 class Legend(Artist):
     """
     Place a legend on the axes at location loc.  Labels are a
@@ -93,7 +95,8 @@
                  handletextsep = None, # the space between the legend line and legend text
                  axespad = None,       # the border between the axes and legend edge
 
-                 shadow = None
+                 shadow = None,
+                 scatter_handle_yoffsets=None,
                  ):
         """
   parent                # the artist that contains the legend
@@ -134,6 +137,16 @@
             self.prop=prop
         self.fontsize = self.prop.get_size_in_points()
 
+        # introduce y-offset for handles of the scatter plot
+        if scatter_handle_yoffsets is None:
+            # offset only when numpoints > 2
+            if self.numpoints > 2:
+                self._scatter_handle_yoffsets = [4./8., 5./8., 3./8.]
+            else:
+                self._scatter_handle_yoffsets = [4./8]
+        else:
+            self._scatter_handle_yoffsets = scatter_handle_yoffsets
+
         if isinstance(parent,Axes):
             self.isaxes = True
             self.set_figure(parent.figure)
@@ -306,15 +319,32 @@
                 ret.append(legline)
 
             elif isinstance(handle, RegularPolyCollection):
-                if self.numpoints == 1:
-                    xdata = np.array([left])
-                p = Rectangle(xy=(min(xdata), y-3/4*HEIGHT),
-                              width = self.handlelen, height=HEIGHT/2,
-                              )
-                p.set_facecolor(handle._facecolors[0])
-                if handle._edgecolors != 'none' and len(handle._edgecolors):
-                    p.set_edgecolor(handle._edgecolors[0])
-                self._set_artist_props(p)
+                # the ydata values set here have no effects as it will
+                # be updated in the _update_positions() method.
+                ydata = (y-HEIGHT/2)*np.ones(np.asarray(xdata_marker).shape, float)
+
+                size_max, size_min = max(handle.get_sizes()),\
+                                     min(handle.get_sizes())
+                size_cycle = cycle([.5*(size_max+size_min),
+                                    size_max,
+                                    size_min
+                                    ])
+
+                # we may need to scale these sizes by "markerscale"
+                # attribute. But other handle types does not seem
+                # to care about this atribute and it is currently ignored.
+                handle_sizes = [s for _, s in izip(xdata_marker,
+                                                   size_cycle)]
+
+                
+                p = type(handle)(handle.get_numsides(),
+                                 rotation=handle.get_rotation(),
+                                 sizes=handle_sizes,
+                                 offsets=zip(xdata_marker,ydata),
+                                 transOffset=self.get_transform())
+
+                p.update_from(handle)
+                p.set_figure(self.figure)
                 p.set_clip_box(None)
                 p.set_clip_path(None)
                 ret.append(p)
@@ -532,6 +562,13 @@
             elif isinstance(handle, Rectangle):
                 handle.set_y(y+1/4*h)
                 handle.set_height(h/2)
+            elif isinstance(handle,RegularPolyCollection):
+                offsets = handle.get_offsets()
+                xvals = [x for (x, _) in offsets]
+                yvals = [y+h*f for _, f in izip(xvals,
+                                                cycle(self._scatter_handle_yoffsets))]
+                handle.set_offsets(zip(xvals, yvals))
+                
 
         # Set the data for the legend patch
         bbox = self._get_handle_text_bbox(renderer)
Index: lib/matplotlib/collections.py
===================================================================
--- lib/matplotlib/collections.py	(revision 6220)
+++ lib/matplotlib/collections.py	(working copy)
@@ -148,6 +148,12 @@
         result = result.inverse_transformed(transData)
         return result
 
+    def get_window_extent(self, renderer):
+        bbox = self.get_datalim(transforms.IdentityTransform())
+        #TODO:check to ensure that this does not fail for
+        #cases other than scatter plot legend
+        return bbox
+
     def _prepare_points(self):
         """Point prep for drawing and hit testing"""
 
@@ -413,7 +419,19 @@
         else:
             self._edgecolors = self.to_rgba(self._A, self._alpha)
 
+    def update_from(self, other):
+        'copy properties from other to self'
 
+        artist.Artist.update_from(self, other)
+        self._antialiaseds = other._antialiaseds
+        self._edgecolors_original = other._edgecolors_original
+        self._edgecolors = other._edgecolors
+        self._facecolors_original = other._facecolors_original
+        self._facecolors = other._facecolors
+        self._linewidths = other._linewidths
+        self._linestyles = other._linestyles
+        self._pickradius = other._pickradius
+
 # these are not available for the object inspector until after the
 # class is built so we define an initial set here for the init
 # function and they will be overridden after object defn
@@ -686,6 +704,7 @@
         """
         Collection.__init__(self,**kwargs)
         self._sizes = sizes
+        self._numsides = numsides
         self._paths = [self._path_generator(numsides)]
         self._rotation = rotation
         self.set_transform(transforms.IdentityTransform())
@@ -702,7 +721,16 @@
     def get_paths(self):
         return self._paths
 
+    def get_numsides(self):
+        return self._numsides
 
+    def get_rotation(self):
+        return self._rotation
+
+    def get_sizes(self):
+        return self._sizes
+
+
 class StarPolygonCollection(RegularPolyCollection):
     """
     Draw a collection of regular stars with *numsides* points."""